org.opengis.cite.ogcapifeatures10.collections

## Class Features

- java.lang.Object
- - org.opengis.cite.ogcapifeatures10.CommonFixture
  - - org.opengis.cite.ogcapifeatures10.CommonDataFixture
    - - org.opengis.cite.ogcapifeatures10.collections.AbstractFeatures
      - - org.opengis.cite.ogcapifeatures10.collections.Features

-     public class Features
      extends AbstractFeatures

  A.2.7. Features {root}/collections/{collectionId}/items
  Author:
    Lyn Goltz

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.opengis.cite.ogcapifeatures10.collections.AbstractFeatures

      `AbstractFeatures.CollectionResponseKey, AbstractFeatures.ResponseData`

  - ### Field Summary

    - ### Fields inherited from class org.opengis.cite.ogcapifeatures10.collections.AbstractFeatures

      `collectionIdAndResponse, collections, iut`

    - ### Fields inherited from class org.opengis.cite.ogcapifeatures10.CommonDataFixture

      `noOfCollections`

    - ### Fields inherited from class org.opengis.cite.ogcapifeatures10.CommonFixture

      `requestLoggingFilter, responseLoggingFilter, rootUri`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Features()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Iterator<Object[]>` | `collectionItemUris(org.testng.ITestContext testContext)`
    `void` | `validateFeaturesOperation(org.testng.ITestContext testContext, Map<String,Object> collection)` Abstract Test 13: /ats/core/fc-op Test Purpose: Validate that features can be identified and extracted from a Collection using query parameters.
    `void` | `validateFeaturesResponse_FeaturesProperty(Map<String,Object> collection)` Abstract Test 22, Test Method 2
    `void` | `validateFeaturesResponse_Links(Map<String,Object> collection)` Abstract Test 22, Test Method 4 (Abstract Test 23)
    `void` | `validateFeaturesResponse_NumberMatched(Map<String,Object> collection)` Abstract Test 22, Test Method 6 (Abstract Test 25)
    `void` | `validateFeaturesResponse_NumberReturned(Map<String,Object> collection)` Abstract Test 22, Test Method 7 (Abstract Test 26)
    `void` | `validateFeaturesResponse_TimeStamp(Map<String,Object> collection)` Abstract Test 22, Test Method 5 (Abstract Test 24)
    `void` | `validateFeaturesResponse_TypeProperty(Map<String,Object> collection)` Abstract Test 22, Test Method 1

    - ### Methods inherited from class org.opengis.cite.ogcapifeatures10.collections.AbstractFeatures

      `collectionPaths, findFeaturesUrlForGeoJson, isExplode, isRequired, retrieveRequiredInformationFromTestContext, validateFeaturesProperty, validateLinks, validateNumberMatched, validateNumberReturned, validateTimeStamp, validateTypeProperty`

    - ### Methods inherited from class org.opengis.cite.ogcapifeatures10.CommonDataFixture

      `createListOfMediaTypesToSupportForFeatureCollectionsAndFeatures, createListOfMediaTypesToSupportForFeatureCollectionsAndFeatures, createListOfMediaTypesToSupportForOtherResources, getApiModel, noOfCollections, requirementClasses, retrieveApiModel`

    - ### Methods inherited from class org.opengis.cite.ogcapifeatures10.CommonFixture

      `clearMessages, getRequest, getResponse, init, initCommonFixture`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Features

          public Features()

  - ### Method Detail

    - #### collectionItemUris

          public Iterator<Object[]> collectionItemUris(org.testng.ITestContext testContext)

    - #### validateFeaturesOperation

          public void validateFeaturesOperation(org.testng.ITestContext testContext,
                                                Map<String,Object> collection)

           Abstract Test 13: /ats/core/fc-op
           Test Purpose: Validate that features can be identified and extracted from a Collection using query parameters.
           Requirement: /req/core/fc-op

           Test Method
             1. For every feature collection identified in Collections, issue an HTTP GET request to the URL /collections/{collectionId}/items where {collectionId} is the id property for a Collection described in the Collections content.
             2. Validate that a document was returned with a status code 200.
             3. Validate the contents of the returned document using test /ats/core/fc-response.

      Parameters:
        `testContext` - used to fill the FEATUREIDS, never `null`
        `collection` - the collection under test, never `null`

    - #### validateFeaturesResponse_TypeProperty

          public void validateFeaturesResponse_TypeProperty(Map<String,Object> collection)

      Abstract Test 22, Test Method 1

           Abstract Test 22: /ats/core/fc-response
           Test Purpose: Validate that the Feature Collections complies with the require structure and contents.
           Requirement: /req/core/fc-response

           Test Method
             1. Validate that the type property is present and has a value of FeatureCollection

      Parameters:
        `collection` - the collection under test, never `null`

    - #### validateFeaturesResponse_FeaturesProperty

          public void validateFeaturesResponse_FeaturesProperty(Map<String,Object> collection)

      Abstract Test 22, Test Method 2

           Abstract Test 22: /ats/core/fc-response
           Test Purpose: Validate that the Feature Collections complies with the require structure and contents.
           Requirement: /req/core/fc-response

           Test Method
             2. Validate the features property is present and that it is populated with an array of feature items.

      Parameters:
        `collection` - the collection under test, never `null`

    - #### validateFeaturesResponse_Links

          public void validateFeaturesResponse_Links(Map<String,Object> collection)

      Abstract Test 22, Test Method 4 (Abstract Test 23)

           Abstract Test 22: /ats/core/fc-response
           Test Purpose: Validate that the Feature Collections complies with the require structure and contents.
           Requirement: /req/core/fc-response

           Test Method
             4. If the links property is present, validate that all entries comply with /ats/core/fc-links

           Abstract Test 23: /ats/core/fc-links
           Test Purpose: Validate that the required links are included in the Collections document.
           Requirement: /req/core/fc-links, /req/core/fc-rel-type

           Test Method:
           Verify that the response document includes:
             1. a link to this response document (relation: self),
             2. a link to the response document in every other media type supported by the server (relation: alternate).

           Verify that all links include the rel and type link parameters.

      Parameters:
        `collection` - the collection under test, never `null`

    - #### validateFeaturesResponse_TimeStamp

          public void validateFeaturesResponse_TimeStamp(Map<String,Object> collection)

      Abstract Test 22, Test Method 5 (Abstract Test 24)

           Abstract Test 22: /ats/core/fc-response
           Test Purpose: Validate that the Feature Collections complies with the require structure and contents.
           Requirement: /req/core/fc-response

           Test Method
             5. If the timeStamp property is present, validate that it complies with /ats/core/fc-timeStamp

           Abstract Test 24: /ats/core/fc-timeStamp
           Test Purpose: Validate the timeStamp parameter returned with a Features response
           Requirement: /req/core/fc-timeStamp

           Test Method: Validate that the timeStamp value is set to the time when the response was generated.

      Parameters:
        `collection` - the collection under test, never `null`

    - #### validateFeaturesResponse_NumberMatched

          public void validateFeaturesResponse_NumberMatched(Map<String,Object> collection)
                                                      throws URISyntaxException

      Abstract Test 22, Test Method 6 (Abstract Test 25)

           Abstract Test 22: /ats/core/fc-response
           Test Purpose: Validate that the Feature Collections complies with the require structure and contents.
           Requirement: /req/core/fc-response

           Test Method
             6. If the numberMatched property is present, validate that it complies with /ats/core/fc-numberMatched

           Abstract Test 25: /ats/core/fc-numberMatched
           Test Purpose: Validate the numberMatched parameter returned with a Features response
           Requirement: /req/core/fc-numberMatched

           Test Method: Validate that the value of the numberMatched parameter is identical to the number of features in the feature collections that match the selection parameters like bbox, datetime or additional filter parameters.

      Parameters:
        `collection` - the collection under test, never `null`
      Throws:
        `URISyntaxException` - if the creation of a uri fails

    - #### validateFeaturesResponse_NumberReturned

          public void validateFeaturesResponse_NumberReturned(Map<String,Object> collection)

      Abstract Test 22, Test Method 7 (Abstract Test 26)

           Abstract Test 22: /ats/core/fc-response
           Test Purpose: Validate that the Feature Collections complies with the require structure and contents.
           Requirement: /req/core/fc-response

           Test Method
             7. If the numberReturned property is present, validate that it complies with /ats/core/fc-numberReturned

           Abstract Test 26: /ats/core/fc-numberReturned
           Test Purpose: Validate the numberReturned parameter returned with a Features response
           Requirement: /req/core/fc-numberReturned

           Test Method: Validate that the numberReturned value is identical to the number of features in the response.

      Parameters:
        `collection` - the collection under test, never `null`

Copyright © 2020 Open Geospatial Consortium. All rights reserved.